#include <iostream>
#include <cmath>
#include "Infiltration.h"
#include "Parameters.h"

using namespace std;

Parameters param;

float Infiltration::setFf(float time, float Pe, float ponding, int k, float O0L_, int i){
//Gathers parameters from the class "Parameters"
    float Hc = param.getHc();
    float Ks = param.getKs();
    float Os = param.getOs();
    float timestep = param.getTimestep();

    float Fp;
    float tp;
    float t = 0;
    float Ftest;

    if (i == 0){
        O0L = O0L_;
    }
//Calculates infiltration capacity if the precipitation rate would be high enough
    if (k > ktest){
        deltatime = time;
        deltaF[k] = F;
        ktest = k;
        O0L = O0L_;
    }else if(k < ktest){
        ktest = k;
        O0L = O0L_;
    }
    Ftest1 = F - deltaF[k] + Pe*timestep;
    ftest = Ks*((Hc*(Os-O0L))/Ftest1+1);

    Fp = (Hc*Ks*(Os-O0L))/(Pe-Ks);
    tp = Fp/Pe;
    Ftest = F - deltaF[k];

    if(Pe > 0 && Pe < Ks){
        F = F + Pe*timestep;
        f = Pe;
    }else if (tp < timestep && Pe > ftest){
        while (Fpot < (Ftest2 - 0.0001)){    //iterates Fpot against Ftest similar to the way they do it in GA
            if (Fpot < Ftest2){              // The number of zeros decides the accurancy, but high accurancy leads to high running time
                Fpot = Fpot + 0.00011;      // adds a small sum to Fpot each loop til Fpot is closer than 0,001 from Ftest
                Ftest2 = Ks*(time-deltatime+timestep)+Hc*(Os-O0L)*log(1+(Fpot/(Hc*(Os-O0L))));
            }
        }
        F = F + Ftest2;
        f = Ks*((Hc*(Os-O0L))/(F-deltaF[k])+1);
    }else if (Pe > Ks ){
        while (t < time - deltatime + timestep){
            Ftest = Ftest + 0.0001;
            t = tp + (1/Ks)*(Ftest-Fp+Hc*(Os-O0L)*log((Hc*(Os-O0L)+Fp)/(Hc*(Os-O0L)+Ftest)));
        }
        if(t <= tp){
            F = F + Pe*timestep;
            f = Pe;
        }else{
            F = F + f*timestep;
            f = Ks*((Hc*(Os-O0L))/(F-deltaF[k])+1);
        }
    }else if (ponding > 0){
        F = F + f*timestep;
        f = Ks*((Hc*(Os-O0L))/(F-deltaF[k])+1);
    }else{
        f = 0;
    }
}
float Infiltration::getF(){
    return F;
}
float Infiltration::getf(){
    return f;
}
float Infiltration::getftest(){
    return ftest;
}
float Infiltration::getdeltaF(int k){
    return deltaF[k];
}


