#include <iostream>
#include <cmath>
#include <string>
#include <cstdlib>
#include "Parameters.h"

using namespace std;

float Parameters::getKs(){
    return Ks;
}
float Parameters::getYb(){
    return Yb;
}
float Parameters::getlambda(){
    return lambda;
}
float Parameters::getOs(){
    return Os;
}
float Parameters::getOi(){
    return Oi;
}
float Parameters::getOr(){
    return Or;
}
float Parameters::getORi(){
    ORi = (Oi-Or)/(Os-Or);        //Relative initial volumetric watercontent
    return ORi;
}
float Parameters::getKi(){
    Ki = Ks*pow(ORi,3+2/lambda); //initial soilmoisture conductivity
    return Ki;
}
float Parameters::getHc(){
    Hc = Yb*((2+3*lambda)/(1+3*lambda)); //initial soilmoisture conductivity
    return Hc;
}
float Parameters::getTimestep(){
    float timestep = minutes/60;
    return timestep;
}
char Parameters::getPond(char* outPond){ //gathers if ponding and stores it in a string
    char str[10];
    for(int i = 0; i < 10; ++i){
        outPond[i] = Pond[i];
  }
}
char Parameters::getfilename(char* outFilename){ //gathers filename and stores it in a string
    char str[50];
    for(int i = 0; i < 50; ++i){
        outFilename[i] = filename[i];
  }
}
float Parameters::geterror(){
    float error;
    if (Ks<0||Yb<0||lambda<0||Os<0||Oi<0||Or<0||ORi<0||Ki<0||Hc<0||minutes<0){
        cout << "ERROR: A Parameter in the class Parameters is < 0" << endl; //Error message returned
        exit(EXIT_FAILURE);                //Exit the program
    }else if (Or > Oi || Oi > Os || Or > Os){
        cout << "EROOR: The variable Or > Oi or Oi > Os or Or < Os" << endl; //Error message returned
        exit(EXIT_FAILURE);
    }else if (Or >= 1 || Oi >= 1 || Os >= 1){
        cout << "ERROR: Or or Oi or Os >= 1" << endl; //Error message returned
        exit(EXIT_FAILURE);
    }
    return error;
}






