#ifndef PARAMETERS_H
#define PARAMETERS_H
#include <string>



class Parameters{
    public:
        float getKs();
        float getHc();
        float getYb();
        float getlambda();
        float getOs();
        float getOi();
        float getOr();
        float getTimestep();
        int getN();
        char getPonded();
        float geterror();

        float getORi();
        float getdOi();
        float getKi();

        char getPond(char* outpond);
        char getfilename(char* outfilename);

    private:
//Set parameters. Do not change
        float error = 0;
        float minutes = 0.5;    //interval between each timestep
        float ORi;
        float Ki;
        float Hc;       //Wetting front capillary pressure
//Ponding
        char Pond[10] = "Yes"; //if ponding is allowed, write "Yes", if not, write "No"
//Precipitation file
        char filename[50] = "Precipitation.txt"; //Enter the name of the file where precipitation data is stored
//Soil properties
//SOIL 1, SAND
//        float Ks = 23.56;     //saturated Conductivity
//        float Yb = 7.26;      //Bubbling pressure
//        float lambda = 0.694;        //Pore size distribution (lambda)
//        float Os = 0.417;         //porosity
//        float Oi = 0.033;       //Initial moisture content
//        float Or = 0.02;        //Residual soil moisture content
//SOIL 4, LOAM
//        float Ks = 1.32;     //saturated Conductivity
//        float Yb = 11.15;      //Bubbling pressure
//        float lambda = 0.252;        //Pore size distribution (lambda)
//        float Os = 0.434;         //porosity
//        float Oi = 0.117;       //Initial moisture content
//        float Or = 0.027;        //Residual soil moisture content
//SOIL 11, CLAY
//        float Ks = 0.06;     //saturated Conductivity
//        float Yb = 37.30;      //Bubbling pressure
//        float lambda = 0.165;        //Pore size distribution (lambda)
//        float Os = 0.385;         //porosity
//        float Oi = 0.272;       //Initial moisture content
//        float Or = 0.09;        //Residual soil moisture content
//SOIL, GREEN ROOF
        float Ks = 43.928;     //saturated Conductivity
        float Yb = 8;      //Bubbling pressure
        float lambda = 0.6;        //Pore size distribution (lambda)
        float Os = 0.4;         //porosity
        float Oi = 0.2302;       //Initial moisture content
        float Or = 0.12;        //Residual soil moisture content
};

#endif // PARAMETERS_H
