#include <iostream>
#include <fstream>
#include <cmath>
#include <windows.h>
//Includes the classes
#include "soilMoisture.h"
#include "getPrecipitation.h"
#include "Parameters.h"
#include "Infiltration.h"
#include "Infiltration_depth.h"
#include "Ponding.h"

using namespace std;

int main(){
//Allows the program to print to the file "Output", and sets print precision = 3 decimals
    ofstream theFile("Output.txt");
    std::cout.precision(3);
//Allows the program to enter classes, and name class objects
    getPrecipitation number;
    Parameters Par;
    Infiltration Ff;
    soilMoisture output;
    Infiltration_depth getZ;
    Ponding Pond;
//Runs through the precipitation file and reads the length of file
    number.setLength(); int length = number.getLength();
//Stores the Pe array and reads from file Precipitation
    char filename[50];                         //initialize a variable of type char to store the filename
    filename[50] = Par.getfilename(filename);  //The function "getfilename" returns the file name from "Parameters" and Stores the file name as a char "filename"
    ifstream fp;                               //Makes an input file stream class
    fp.open(filename);                         //Opens the file named in the variable "filename"
    float Prec;
    float Pe[length];                           //Creates a precipitation vector with the  length "length"
    int j = 0;
    while(fp.good()){                           //While-loop runs through the file "filename" until the end
		fp >> Prec;                             //Each data is stored as "Prec"
		Pe[j] = Prec;                           //Stores Precipitation value in a vector
		j++;                                    //increase the value of j with one
    }
    fp.close();                                 //Closes the file "filename"
//INITIALIZTION;
    float ORi=Par.getORi(),Hc=Par.getHc(),Yb=Par.getYb(),lambda=Par.getlambda(),timestep=Par.getTimestep(); //Gets parameters from the class "Parameters"
    float time=0;
    float Oi=Par.getOi(),Os=Par.getOs(),Ks=Par.getKs(),Ki=Par.getKi(),Or=Par.getOr(); //Gets parameters from the class "Parameters"
    float Freal=0;
    float deltaF = 0;
    float f = 0;
    float ftest = 0;
    float O0[4]={0}; O0[0]=Oi;
    float OR0[4]={0}; OR0[0] = ORi;
    float K0[4]={0}; K0[0]=Ki;
    float Z[4]={0}; Z[0]= 10;
    int k = 0;
    float ponding = 0;
    float Runoff = 0;
    float PeL = 0;
    Par.geterror();        //Checks if it is an error in the input values in "Parameters"
//STARTS THE FOR LOOP
    for (int i = 0; i < length; i++){       //Starts the for-loop that runs through each precipitation data
//If I want to slow down the output
        Sleep(0);                           //Slows down the program if the user wants to follow the information printed to the screen
// changes the time in steps of timestep
        time = time + timestep;             //Increases time with one timestep
//changes k if a new wetting front is formed
        if (Pe[i] > Ks && PeL < Ks && O0[k] < Os){      //If a new wetting front is formed k needs to be increased for the following operations
            k++;                            //Number of wetting fronts "k" is increased by one
        }
//Calculates advance and controls the water demand for wetting front (1 to k-1)
        float Pek[4]={0};                   //Creates a vector to control Water demand for wetting front 1-(k-1)
        float Vzk[4]={0};                   //Creates a vector to control Volume for wetting front 1-(k-1)
        float PeR = Pe[i];                  //Creates a variable for residual rainfall
        for(int j = 1; j < k; j++){         //For wetting front 1-(k-1)
            Vzk[j] = Z[j]*(O0[j]-O0[j-1]);  //Check initial water volume
            getZ.setZKn(K0[j],K0[j-1],O0[j],O0[j-1],Z[j],OR0[j],OR0[j-1]);  //Get new depth value
            Z[j] = getZ.getZKn();
            Pek[j] = (Z[j]*(O0[j]-O0[j-1])-Vzk[j]);  //Water demand is new volume - initial volume Vzk
            PeR = PeR-Pek[j]/timestep;               //Residua rainfall is rainfall - water demand for all the wetting fronts
        }
//Gets "f", "ftest", "Freal", "deltaF", and "error" form the class "Infiltration"
        Ff.setFf(time,Pe[i], ponding, k, O0[k-1], i);
        f = Ff.getf();
        ftest = Ff.getftest();
        Freal = Ff.getF();
        deltaF = Ff.getdeltaF(k);
//Considers if the area have free surface runoff or if Ponding occurs
        Pond.setPonding(f,Pe[i],timestep,i);        //Calculates "ponding" and "Runoff" from the class "Ponding"
        ponding = Pond.getPonding();
        Runoff = Pond.getRunoff();
//New.......................................................................................
        if (Pe[i] > Ks && PeL < Ks && O0[k] < Os){  //If "Pe" > Ks and a new wetting front is formed --> situation New
            getZ.setZK0(O0[k-1],OR0[k-1]);                  //get new depth equals dry depth
            Z[k] = getZ.getZK0();
            if(Pe[i] > ftest){                      //"Pe" is higher than infiltration capacity
                O0[k] = Os;                         //the soil is saturated
            }else{
                output.setO0(Z[k],PeR,O0[k-1],OR0[k-1]);    //else get soil moisture content
                O0[k] = output.getO0();
            }
        }else{
//C.......................................................................................
            if (Pe[i] >= ftest){                    //if "Pe" is higher than infiltration capacity
                getZ.setZs(O0[k-1],Z[k]);               //get new depth
                Z[k] = getZ.getZs();
                O0[k] = Os;                         //The soil is saturated
            }
//B.......................................................................................
            float O0test = O0[k];                   //Creates a test variable "O0test"
            float Ztest = Z[k];                     //Creates a test variable "Ztest"
            if (Pe[i] < ftest && Pe[i] >= Ks){      //If Pe > ks but less than infiltration capacity --> situation B
                float Ftest = Freal-deltaF-f*timestep; //Creates a test variable "Ftest"
                while (Ftest < Freal - deltaF){     //Runs as long as the volume of "Ftest" is less than the infiltrated water volume
                        O0test = O0test + 0.0001; //increase "O0test" in small steps
                        getZ.setZK1(K0[k],O0test,O0[k-1],Z[k],OR0[k], OR0[k-1]); //Get new depth with new O0test as input
                        Ztest = getZ.getZK1();
                        Ftest = Ztest*(O0test-O0[k-1]); //Calculate new "Ftest" volume
                }
                Z[k] = Ztest;                   //New depth is set to "Ztest"
                O0[k] = O0test;                 //New soil moisture content is set to "O0test"
            }
//A.......................................................................................
            if (Pe[i] < Ks){                        //If "Pe" < "Ks" --> Situation A
                if (ponding > 0){                   //If still ponding --> situation C
                    getZ.setZs(O0[k-1],Z[k]);           //New depth
                    Z[k] = getZ.getZs();
                    O0[k] = Os;                     //The soil is fully saturated
                }else{
                    float Ftest = Freal-deltaF-0.001; //Creates a test variable "Ftest"
                    while (Ftest < Freal-deltaF){   //Runs as long as the volume of "Ftest" is less than the infiltrated water volume
                        Ztest = Ztest+0.001;       //increase "Ztest" in small steps
                        output.setO0(Ztest,PeR,O0[k],OR0[k-1]); //Get new "O0" with new O0test as input
                        O0test = output.getO0();
                        Ftest = Ztest*(O0test-O0[k-1]); //Calculate new "Ftest" volume
                    }
                    Z[k] = Ztest;                   //New depth is set to "Ztest"
                    O0[k] = O0test;                 //New soil moisture content is set to "O0test"
                }
            }
//..........merges to wetting fronts if they reach the same level..............................
            if (Z[k] > Z[k-1] && k > 0){            //If The depth of one wetting front exceeds the depth of the neighboring wetting front
                Z[k-1] = ((O0[k]-O0[k-1])*Z[k]+(O0[k-1]-O0[k-2])*Z[k-1])/(O0[k]-O0[k-2]); //New depth of both wetting fronts
                O0[k-1] = O0[k];                    //New soil moisture content of both wetting fronts
                Z[k] = 0, O0[k] = 0, K0[k] = 0, OR0[k] = 0; //the last wetting front is deleted because the wetting fronts are merged to one
                k--;                                //Number of wetting fronts "k" is reduced by one
            }
        }
        OR0[k] = (O0[k]-Or)/(Os-Or);                //OR0 is set using the new calculated soil moisture content
        K0[k] = Ks*pow(OR0[k],3+2/lambda);          //K0 is set using the new calculated relative volumetric soil moisture content

//PRINTS TO SCREEN
        std::cout << "time " <<  time;
        std::cout << ": Pe " <<  Pe[i];
        std::cout << ": k " <<  k;
        std::cout<< ": Z[1] " << Z[1];
        std::cout<< ": O0 " << O0[k];
//PRINTS TO FILE
        std::cout<< std::fixed << endl;
        theFile<<time<<" "<<Pe[i]<<" "<<Freal<<" "<<f<<" "<<ftest<<" "<<Z[0]<<" "<<Z[1]<<" "<<Z[2]<<" "<<Z[3]<<" "<<O0[0]<<" "<<O0[1]<<" "<<O0[2]<<" "<<O0[3]<<" "<<OR0[0]<<" "<<OR0[1]<<" "<<OR0[2]<<" "<<OR0[3]<<" "<<K0[0]<<" "<<K0[1]<<" "<<K0[2]<<" "<<K0[3]<<" "<<Pek[0]<<" "<<Pek[1]<<" "<<Pek[2]<<" "<<ponding<<" "<<Runoff<<" "<<endl;
        PeL = Pe[i];                    //Stores the last Precipitation value for use to check whether a new wetting front is formed
    }
//PRINTS INITIAL VALUES TO SCREEN
    cout << endl << "length of file = " << length << endl << "time = " << time << endl << "timestep = " << timestep << endl << "Ks = " << Ks << endl << "Ki = " << Ki << endl << "Hc = " << Hc << endl << "Yb = " << Yb << endl << "lambda = " << lambda << endl << "Os = " << Os << endl << "Oi = " << Oi << endl << "Or = " << Or << endl << "ORi = " << ORi << endl << endl;
    theFile.close();                    //Closes the output file
}







