#include "soilMoisture.h"
#include <iostream>
#include <cmath>
#include "Parameters.h"
using namespace std;
Parameters  Par;
float soilMoisture::setO0(float Z,float PeR,float O0_, float OR0L){
    //returns parameters from the class "parameters"
    float Yb = Par.getYb();
    float Ks = Par.getKs();
    float Os = Par.getOs();
    float lambda = Par.getlambda();
    float Or = Par.getOr();
    float timestep = Par.getTimestep();
    //sets the correction factor p
    float p;
    if(PeR > 0){
        p = 1;
    }else{
        p = 1.7;
    }
    //RK4 calculations k1-k4
    k1 = timestep*((1/Z)*(PeR-Ks*(pow((O0_-Or)/(Os-Or),3+(2/lambda)))-(p*Ks*((Yb/lambda)*(pow((O0_-Or)/(Os-Or),(3+(1/lambda)))-pow(OR0L,(3+(1/lambda))))/(3+(1/lambda)))/Z)));
    k2 = timestep*((1/Z)*(PeR-Ks*(pow(((O0_+k1*0.5)-Or)/(Os-Or),3+(2/lambda)))-(p*Ks*((Yb/lambda)*(pow(((O0_+k1*0.5)-Or)/(Os-Or),(3+(1/lambda)))-pow(OR0L,(3+(1/lambda))))/(3+(1/lambda)))/Z)));
    k3 = timestep*((1/Z)*(PeR-Ks*(pow(((O0_+k2*0.5)-Or)/(Os-Or),3+(2/lambda)))-(p*Ks*((Yb/lambda)*(pow(((O0_+k2*0.5)-Or)/(Os-Or),(3+(1/lambda)))-pow(OR0L,(3+(1/lambda))))/(3+(1/lambda)))/Z)));
    k4 = timestep*((1/Z)*(PeR-Ks*(pow(((O0_+k3)-Or)/(Os-Or),3+(2/lambda)))-(p*Ks*((Yb/lambda)*(pow(((O0_+k3)-Or)/(Os-Or),(3+(1/lambda)))-pow(OR0L,(3+(1/lambda))))/(3+(1/lambda)))/Z)));
    O0 = O0_+(k1+2*k2+2*k3+k4)/6; //adds delta O0 to O0
}
float soilMoisture::getO0(){
    return O0;
}











